/*
 cs_textfonts.h
  MyCSeries include for MyCSeries's text fonts (non-native rendering)
   WARNING: Much of cs_text is not implemented!

  Version 0.4

  Created: February 8, 2006
  Revised: June 24, 2007


    Version 1.0 has not yet been reached.  If you have a name conflict,
  please feel free to make contact via E-mail with a list of alternative
  names, so the name conflict can be resolved by the next release.
*/

/*
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain.  You may use,
 * modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but WITHOUT
 * ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY DISCLAIMED.
 *  This includes but is not limited to warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef __CS_TEXT_FONTS_H
# define __CS_TEXT_FONTS_H

/* constants */

  enum
  {
    /* every glyph is rendered at multiples of this;
      if the quotient of the closest highest glyph bitmap scale to the point
      scale goes under two, then another glyph bitmap has to be rendered
    */
     _cs_glyph_scale_multiplier   = 180,

    /* starting value for MyCSeries fonts */
     _cs_custom_font_delta        = 0x10000
  };

/* structures */

  typedef struct cs_encoding_map/*(1040)*/
  {
     UInt8            flags, face, region, script;

     UInt8 reserved[12]; /* future use only - set to zero */

    /* glyph index list - 256 is the `undefined' symbol */
     SInt32           index[257];
  } cs_encoding_map;

/* active (in memory) glyphs */

  typedef struct cs_glyph_data/*(32+)*/
  {
     UInt32           flags;
     sfixed           scale; /* truetype scale */
     sfixed           width; /* truetype width */

     UInt16           bitmap_width, bitmap_height;

    /* where available */
     UInt8            bitmap_scale, style_bits, encoding_script, char_index;

    /* truetype data - where available */
     UInt16           contour_count, outline_point_count;
     void             *outline_data;

    /* cached bitmap data; aligned to byte boundary */
     UInt8            *pixel_data;
  } cs_glyph_data;

/* active fonts */

  typedef struct cs_font_data/*(64+)*/
  {
    /* internal name - doesn't necessarily reflect the file name */
     char             name[32];

     UInt32           flags;
     ufixed           ascent, descent; /* sum is total vertical space per line */
     ufixed           bold_width;

     UInt32           map_count; /* current number of available encoding maps */
     UInt32           glyph_count; /* current number of available glyphs */

     cs_encoding_map  *map; /* entire list of encoding maps; searched to match */
     cs_glyph_data    *glyph;
  } cs_font_data;

/* prototypes */

  EXTERN_API_C(cs_font_data*) get_font_data(
    SInt32 font_id); /* the platform font found in the fontspec structure */

# define TXIT_PARAMS                        (cs_textspec *spec, cs_glyph_data *glyph, cs_short_point *line)

  typedef CALLBACK_API_C(int,CSTextIteratorProc) TXIT_PARAMS;

  EXTERN_API_C(int) text_iterator(
    cs_textspec *spec, /* must be a valid pointer */
    cs_short_point *pos,
    UInt8 *src,
    SInt32 encoding,
    int length,
    CSTextIteratorProc proc);

#endif /*!defined(__CS_TEXT_FONTS_H)*/
