/*
 text.c
  source file for MyCSeries text measurements, drawing and truncation

  Version 0.4.1

  Created: December 26, 2005
  Revised: December 31, 2006

 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain.  You may use,
 * modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but WITHOUT
 * ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY DISCLAIMED.
 *  This includes but is not limited to warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <cs_graphics.h>
#include <cs_text.h>
#include <cs_text_fonts.h>
#include <cs_strings.h>

#define __MPWINTERNAL__			1 /* sorry */

#include <ctype.h>

/* ------------ globals */

static cs_textspec	*current_textspec = (cs_textspec*)NULL;

static UInt8		system_table[256] =
   {0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,1,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	1,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0, /* end of ASCII characters */
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
	0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80};

#if 0
# define _WBL					(_WSP|_BLA)
# define _WCT					(_CTL|_WSP)
# define _UPX					(_HEX|_UPP)
# define _LOX					(_HEX|_LOW)

UInt8				__mycs_ctype[256] =
{
	_CTL,_CTL,_CTL,_CTL,_CTL,_CTL,_CTL,_CTL,
	_CTL,_WCT,_WCT,_WCT,_WCT,_WCT,_CTL,_CTL,
	_CTL,_CTL,_CTL,_CTL,_CTL,_CTL,_CTL,_CTL,
	_CTL,_CTL,_CTL,_CTL,_CTL,_CTL,_CTL,_CTL,
	_WBL,_PUN,_PUN,_PUN,_PUN,_PUN,_PUN,_PUN,
	_PUN,_PUN,_PUN,_PUN,_PUN,_PUN,_PUN,_PUN,
	_DIG,_DIG,_DIG,_DIG,_DIG,_DIG,_DIG,_DIG,
	_DIG,_DIG,_PUN,_PUN,_PUN,_PUN,_PUN,_PUN,
	_PUN,_UPX,_UPX,_UPX,_UPX,_UPX,_UPX,_UPP,
	_UPP,_UPP,_UPP,_UPP,_UPP,_UPP,_UPP,_UPP,
	_UPP,_UPP,_UPP,_UPP,_UPP,_UPP,_UPP,_UPP,
	_UPP,_UPP,_UPP,_PUN,_PUN,_PUN,_PUN,_PUN,
	_PUN,_LOX,_LOX,_LOX,_LOX,_LOX,_LOX,_LOW,
	_LOW,_LOW,_LOW,_LOW,_LOW,_LOW,_LOW,_LOW,
	_LOW,_LOW,_LOW,_LOW,_LOW,_LOW,_LOW,_LOW,
	_LOW,_LOW,_LOW,_PUN,_PUN,_PUN,_PUN,_CTL,
};

UInt8				*__p_CType = __mycs_ctype;
#endif

/* ------------ structures */

/* ------------ private prototypes */

static cs_textspec *update_textspec(cs_textspec *spec);

static int text_draw_routine TXIT_PARAMS;
static int text_hilite_routine TXIT_PARAMS;
static int text_measure_routine TXIT_PARAMS;

/*static int map_glyph(cs_textspec *spec, cs_glyph_data *glyph, sfixed posx, sfixed posy);*/

/* ------------ code */

/* glyph code */

#undef DEPTH
#define DEPTH 1
#include "glyph_drawing.h"

#undef DEPTH
#define DEPTH 8
#include "glyph_drawing.h"

#undef DEPTH
#define DEPTH 15
#include "glyph_drawing.h"

#undef DEPTH
#define DEPTH 32
#include "glyph_drawing.h"

/* main code */

int initialize_textspec(cs_textspec *s, void *a, SInt32 f, cs_color_table *t, int p)
{
	if (s==(cs_textspec*)(-1) || (unsigned)p>UINT16_MAX)
		return -1;
	if (s==(cs_textspec*)NULL) /* current graphics port textspec */
		s = current_textspec;
	((SInt16*)s->privates)[0] = f|0xC000;
	((SInt16*)s->privates)[1] = p;

	*(void**)(s->privates+4) = a; /* pixel data is 16 bytes in */
	*(cs_color_table**)(s->privates+6) = t;

	return (update_textspec(s)==(cs_textspec*)NULL) ? -1 : 0;
}

int set_default_textspec(cs_textspec *s)
{
	if (s==(cs_textspec*)(-1))
		return -1; /* what the heck are tryin' to do here? */
	current_textspec = s;

	return 0;
}

cs_textspec *get_default_textspec()
{
	return current_textspec;
}

static int		max_width, max_height;
static int		prev_textwidth, prev_textheight;
static int		prev_textposition_x, prev_textposition_y;

int ts_textwidth(cs_textspec *spec, void *text, SInt32 encoding, int length)
{
	int				err;

	prev_textwidth = max_width = 0;
	prev_textposition_x = prev_textposition_y = INT_MIN;

	if ((spec=update_textspec(spec))==(cs_textspec*)NULL || text==NULL || length<=0)
		return 0;
	if ((err=text_iterator(spec,(cs_short_point*)NULL,(UInt8*)text,encoding,length,text_measure_routine))!=0)
		return max_width;

	return err;
}

static map_glyph_proc	current_mapper;

int ts_drawtext(cs_textspec *spec,
	cs_short_point *pos,
	void *text, SInt32 encoding, int length)
{
	UInt8			*s = (UInt8*)text;
	int				x;

	if ((spec=update_textspec(spec))==(cs_textspec*)NULL)
		return -1;
	if ((x=0x3FFF&*(UInt16*)spec->privates)==0 || (unsigned)x>32)
		return -1; /* other pixel formats not supported for text */

	current_mapper = map_glyph_list[x-1];

	if ((encoding>>24)==0) /* function must be zero to draw text */
		return text_iterator(spec,pos,(UInt8*)text,encoding,length,text_draw_routine);

	return 0;
}

int ts_hilitetext(cs_textspec *spec,
	cs_short_point *pos,
	void *text, SInt32 encoding, int length)
{
	int				x;

	if ((spec=update_textspec(spec))==(cs_textspec*)NULL)
		return -1;
	if ((x=0x3FFF&*(UInt16*)spec->privates)==0 || (unsigned)x>32)
		return -1; /* other pixel formats not yet supported for text */

	current_mapper = map_glyph_list[x-1];

	return text_iterator(spec,pos,(UInt8*)text,encoding,length,text_hilite_routine);
}

/* private code */

static int text_draw_routine TXIT_PARAMS
{
	return current_mapper(spec,glyph,line->x,line->y);
}

static int text_hilite_routine TXIT_PARAMS
{ /* not yet implemented */
#pragma unused(buf,spec,glyph,line,sx,sy)

	return 0;
}

static int text_measure_routine TXIT_PARAMS
{
#pragma unused(buf,spec,glyph,sx,sy)
	if (prev_textposition_x!=INT_MIN)
	{
		if (line->x<prev_textposition_x)
			max_width = prev_textwidth;
		prev_textwidth += line->x-prev_textposition_x;
	}
	if (prev_textposition_y!=INT_MIN)
	{
		if (line->y<prev_textposition_y)
			max_height = prev_textheight;
		prev_textheight += line->y-prev_textposition_y;
	}

	prev_textposition_x = line->x;
	prev_textposition_y = line->y;

	return 0;
}

/* text iterator code */

int text_iterator(cs_textspec *spec,
	cs_short_point *pos,
	UInt8 *s,
	SInt32 enc,
	int len,
	CSTextIteratorProc p)
{
	cs_short_point		default_pos, line_pos;
	cs_font_data		*font;
	cs_encoding_map		*map;

	int				char_height; /* scratch until... inner loop */
	int				char_size, index, count;
	UInt8			region = (enc>>4)&0xF, script = enc>>8;

	if ((font=get_font_data(spec->font.id))==(cs_font_data*)NULL)
		return kTS_font_not_found;
	if ((map=font->map)==(cs_encoding_map*)NULL || (count=font->map_count)==0)
		return kTS_encoding_not_found; /* no mappings, no encodings */

	while(map->region!=region || map->script!=script)
	{
		++map;
		if (--count)
			return kTS_encoding_not_found;
	}

	if (len<=0 || s==(UInt8*)NULL || spec->font.size<0)
		return 0;
	if (pos==(cs_short_point*)NULL)
		{pos = &default_pos; pos->x = pos->y = 0;}

	/* calculate our scaled values */
	if ((char_height=spec->font.size)==0)
		char_height = 12;
	pos->y -= UFix16Mul(font->descent,char_height);
	char_height = UFix16Mul(font->ascent+font->descent,char_height);

	line_pos = *pos;

	if ((char_size=(UInt8)(enc>>16))==0)
	{ /* direct UInt8 mapping (MacRoman, Windows-1252, ...) */
		boolean		last_cr = FALSE;

		do
		{
			short_int		i = *s++;

			if ((index=map->index[i])>=0)
				if (p(spec,font->glyph+index,pos)!=0)
					break;
			if (i==13 || (i==10 && !last_cr)) /* line break */
			{
				pos->x = line_pos.x, pos->y = (line_pos.y+=char_height);
				last_cr = i==13;
			} else
				pos->x += font->glyph[index].width>>16;
		} while(--len);
	} else if (char_size<=8)
	{ /* UTF7, UTF8 and special formats */
		do
		{
			short_int		n = *s++;

			if ((index=map->index[n])>=0)
				if (p(spec,font->glyph+index,pos)!=0)
					break;
		} while(--len);
	} else if (char_size<=16)
	{ /* Unicode and special formats */
		do
		{
			short_int		n = *s++;
			short_int		i = *s++;

			if ((index=map->index[i])>=0)
				if (p(spec,font->glyph+index,pos)!=0)
					break;
		} while(--len);
	} else if (char_size==24)
	{ /* Unicode and special formats */
		do
		{
			short_int		r = *s++;
			short_int		n = *s++;
			short_int		i = *s++;

			if ((index=map->index[i])>=0)
				if (p(spec,font->glyph+index,pos)!=0)
					break;
		} while(--len);
	} else if (char_size==32)
	{ /* Unicode and special formats */
		do
		{
			short_int		r = (*s++<<8)|*s++;
			short_int		n = *s++;
			short_int		i = *s++;

			if ((index=map->index[i])>=0)
				if (p(spec,font->glyph+index,pos)!=0)
					break;
		} while(--len);
	} /* other sizes not yet supported */

	return 0;
}

/* updating and initialization */

static cs_textspec *update_textspec(cs_textspec *spec)
{
	cs_color_table	*ctab;
	ARGB32			color, outColor;
	short_int		a, r, g, b, depth;

	if (spec==(cs_textspec*)(-1))
		return (cs_textspec*)NULL;
	if (spec==(cs_textspec*)NULL) /* current graphics port textspec */
		;

/* spec established */
	if ((spec->xslop|spec->yslop)==0)
		spec->xslop = FIXED_ONE, spec->yslop = 0;

	if (((depth=*(UInt16*)spec->privates)&0xC000)==0xC000)
		return spec;

	if ((ctab=*(cs_color_table**)(spec->privates+6))==(cs_color_table*)-1)
		ctab = (cs_color_table*)NULL;

	depth &= 0x3FFF;
	color = spec->color;
	a = color.a, r = color.r, g = color.g, b = color.b;
	if (a>127)
		++a;
	spec->privates[1] = ARGB32_to_pixel(color,depth,_translate_color_closest,ctab);

	if (depth>8)
	{
		INTERPOLATE_ARGB32(&outColor,&color,1+a,0,0,0);
		spec->privates[2] = ARGB32_to_pixel(outColor,depth,_translate_color_moderate,ctab);

		INTERPOLATE_ARGB32(&outColor,&color,129+(a>>1),0,0,0);
		spec->privates[3] = ARGB32_to_pixel(outColor,depth,_translate_color_moderate,ctab);
	}

	return spec;
}

long get_text_width(const cs_fontspec *spec, void *s, SInt32 len)
{
	cs_fontspec		old_font;

	register char	*t = (char*)s;
	int				span = 0;

	if (spec!=(cs_fontspec*)NULL)
	{
		get_port_font(&old_font,1);
		set_port_font(spec,1);
	}
#if TARGET_OS_MAC
	while(len>0)
	{
		short		portion = len>256 ? 256 : len;

		span += TextWidth(t,0,portion);
		len -= 256, t += 256;
	}
#else
#endif
	if (spec!=(cs_fontspec*)NULL)
		set_port_font(&old_font,1);

	return span;
}

/* platform specific code */

#if TARGET_OS_MAC

/* text truncation */

#define CLIP_FROM_START(t,l,w)	do{if((w+=CharWidth(*t++))>=0) break;}while(--l);
#define SCAN_TO_NON_WSP(t,l)	do{if(!(__p_CType[*t++]&_WSP)) break;}while(--l);

/* this still exists because of TruncString's limitations (and you can't
  make reproducable code if it requires something from a particular platform) */
/* this has hardly been tested... this should hardly work */
void *cliptext(void *s, int *_len, int method, sfixed width, sfixed margin)
{
	Point			one_one;
	Fixed			remaining = 0, wid = width, mid = wid>>1;
	Boolean			leading = true;

	register char	*t = (char*)s, *u, *v;
	long			x, m, len = *_len;
	sfixed			span = 0, espan = CharWidth('')<<16;

	if (method<=_cs_clip_at_middle_char && espan>=wid)
		{len=0; goto end;}

	if (len<=0 || t==(char*)NULL)
		return NULL;
	span = get_text_width((cs_fontspec*)NULL,t,len);
	if (span>32767)
		span = 32767;

	if ((wid-=(span<<=16))>=0)
		goto end; /* no truncation is necessary */

	wid += (method&3) ? margin : margin>>1;
	*(SInt32*)&one_one = 0x10001;

	switch(method)
	{
	case _cs_clip_completely:
		goto one;

	case _cs_clip_left_to_right_char:
		wid>>=16;
		CLIP_FROM_START(t,len,wid);
		memmove(s,t,len);
		goto symbol;
	case _cs_clip_right_to_left_char:
		len = PixelToChar((Ptr)s,len,wid,wid,&leading,&remaining,onlyStyleRun,one_one,one_one);
		goto symbol;
	case _cs_clip_at_middle_char:
		len = PixelToChar((Ptr)s,len,mid,mid,&leading,&remaining,onlyStyleRun,one_one,one_one);
	symbol:
		if (len>1)
			if (len<=*_len)
				((char*)s)[len-1] = '';
			else
				len = *_len;
		break;
	case _cs_clip_to_first_word:
		if ((t=(char*)tblchrbit((UInt8*)t,_WSP,len,__p_CType))!=(char*)NULL)
			len = (long)t-(long)s;
		span = get_text_width((cs_fontspec*)NULL,t,len);
		if (span>32767)
			span = 32767;
		if ((wid=width-span)<0)
			goto one;
		break;
	case _cs_clip_left_to_right_word:
		CLIP_FROM_START(t,len,wid);
		if ((u=(char*)tblchrbit((UInt8*)t,_WSP,len,__p_CType))==(char*)NULL)
			{goto one;}
		len -= ((long)u-(long)t);
		SCAN_TO_NON_WSP(u,len);
		memmove(s,u,len);
		break;
	case _cs_clip_right_to_left_word:
		StyledLineBreak((Ptr)s,len,0,len,0,&wid,&len);
		break;
	case _cs_clip_at_middle_word:
		x = PixelToChar((Ptr)s,len,mid,mid,&leading,&remaining,onlyStyleRun,one_one,one_one);
		m = x;
		t = x+(char*)s;
		do{if (__p_CType[*--t]&_WSP) break;}while(--x);
		if (x>0)
			do{if (!(__p_CType[*--t]&_WSP)) break; ;}while(--x);

		if ((v=(char*)tblchrbit((UInt8*)(u=m+(char*)s),_WSP,len-m,__p_CType))==(char*)NULL)
		{
			if ((len=--x)>0)
			{
				wid = width;
				x = PixelToChar((Ptr)s,len,wid,wid,&leading,&remaining,onlyStyleRun,one_one,one_one);
				if (x!=len)
					goto one;
			} else
				goto one;
			break;
		}
		memmove(t,u,len-=((long)v-(long)u));
		break;
	one: len = 1; *(char*)s = ''; /* at least return something */
		break;
/* undefined values do nothing for now */
	default:
		break;
	}
end:
	*_len = len;
	return s;
}

/* fontspec routines */

void get_port_font(cs_fontspec *spec, UInt8 save_qd_bits)
{
	GrafPtr			curPort;

	GetPort(&curPort);
	spec->style &= ~_ts_QuickDraw_face_bits;
#if TARGET_API_MAC_CARBON
	spec->id = GetPortTextFont(curPort);
	spec->style |= GetPortTextFace(curPort)&_ts_QuickDraw_face_bits;
	if (save_qd_bits!=0)
		spec->special = (spec->special&~_ts_special_user_bits)|(GetPortTextFace(curPort)>>4);
	spec->size = GetPortTextSize(curPort);
#else
	spec->id = curPort->txFont;
	spec->style |= curPort->txFace&_ts_QuickDraw_face_bits;
	if (save_qd_bits!=0)
		spec->special = (spec->special&~_ts_special_user_bits)|(curPort->txFace>>4);
	spec->size = curPort->txSize;
#endif
}

void set_port_font(const cs_fontspec *spec, UInt8 restore_qd_bits)
{
	UInt8			face = spec->style&_ts_QuickDraw_face_bits;

	if (restore_qd_bits!=0)
		face |= spec->special<<4; //(spec->special&_ts_special_user_bits)<<4;

	TextFont(spec->id);
	TextFace(face);
	TextSize(spec->size);
}
#endif /*TARGET_OS_MAC*/
