#if 0
#  This is a C/MPW script hybrid!
# Just execute this on the command line, as is - Really!

Unset 1 ; (Evaluate "{0}"=~/()1./)  dev:null ; Set Targ "{1}"
Unset 2 ; (Evaluate "{0}"=~/()2:/)  dev:null
If NOT `Exists "{2}":::MacCSeries.o`
  Echo '# Warning: MacCSeries.o does not already exist.' ; Echo '# Attempting to "Make" it...'
  Begin ; Make "{2}":::MacCSeries.o ; End > "{2}":MacCSeries.o.makeout
  "{2}":MacCSeries.o.makeout
  Delete "{2}":MacCSeries.o.makeout
End
SC "{0}" -o "{0}".o -i "{2}":::include: -sym off -mc68881 -mc68040 -b2 -model farData -proto strict
ILink -o "{Targ}" "{2}":::MacCSeries.o "{0}".o -mf -t 'MPST' -c 'MPS ' -model far 
  -state nouse -compact -pad 0 "{Libraries}"MacRuntime.o "{CLibraries}"StdCLib.o 
  "{Libraries}"Interface.o "{Libraries}"IntEnv.o -sn STDCLIB=Main -sn STDIO=Main 
  -sn INTENV=Main -sn %A5Init=Main -sn SADEV=Main -sn SANELIB=Main 
Echo -n "{Targ} " ; Exit 0
#endif
/*
 test.c

  For MyCSeries version 0.3

  Created: December 29, 2005 9:20 AM EDST
  Revised: November 25, 2006 1:37 PM EDST
*/

#include <cs_system.h>
#include <cs_math.h>

#include <DateTimeUtils.h>
#include <Timer.h>

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#undef isqrt64
#undef isqrt

  UInt32 isqrt64(UInt64 n);
  UInt32 isqrt(UInt32 n);

int main(int argc, char **argv)
{
	cs_init_params	init_params;

	UInt64			v, q;
	SInt64			popcorn, goddamn_tree_huggers;

	char			**a = argv+1;
	SInt32			i = 8347;
	UInt32			t, u;

	if (argc>0 && strcmp(*a,"-sts")==0)
		{++a, --argc; goto skip_timescalers;}

	fputs("Evaluating timescale... (don't move the mouse)\n",stdout);
	fflush(stdout);
	{
		unsigned long		firstDate, currentDate;
		UInt64				firstmcs, lastmcs;

	/* using the DateTime seconds, sync by waiting until two seconds are over */
		GetDateTime(&firstDate);
		do { GetDateTime(&currentDate); } while(currentDate==firstDate);
		GetDateTime(&firstDate);
		do { GetDateTime(&currentDate); } while(currentDate==firstDate);
	/* time this second */
		GetDateTime(&firstDate);
		Microseconds((UnsignedWide*)&firstmcs);
		do { GetDateTime(&currentDate); } while(currentDate==firstDate);
		Microseconds((UnsignedWide*)&lastmcs);
		USub64(lastmcs,firstmcs);
		t = (Int64ToX(lastmcs)/1000.0)+0.5;
		u = Int64Lo(firstmcs)/1000;
		fprintf(stdout,"calculated mcs == %d\n", Int64Lo(lastmcs));
	}

	init_params.init_params_size = 8; // ends after `flags'
	init_params.flags = kCSI_approximate_ms;
	cs_initialize(&init_params);

	fprintf(stdout,"cs_ms_per_second == %d\n", cs_ms_per_second);
	fflush(stdout);

skip_timescalers:
	fprintf(stdout,"NATIVE_TO_LES16(0x3412)     == 0x%04X\n", NATIVE_TO_LES16(0x3412));
	fflush(stdout);

	fprintf(stdout,"NATIVE_TO_LES32(0x436587A9) == 0x%04X\n", NATIVE_TO_LES32(0x436587A9));
	fflush(stdout);

	XSetInt64(popcorn,5000000000.0);
	goddamn_tree_huggers = popcorn;
	SDiv64S32(goddamn_tree_huggers,i);

	fprintf(stdout,"Holy crap!  %lld / %d == %lld...\n", popcorn,i,goddamn_tree_huggers);
	fflush(stdout);

	i = Int64ToX(popcorn)/i+t+u;

	srand(clock());
	SetInt64(v,0x80000000|(rand()<<24)^(rand()<<12)^rand(),(rand()<<24)^(rand()<<12)^rand());

	//	SetInt64(v,0x80000000|(Random()<<16)^Random(),(Random()<<16)^Random());
	fprintf(stdout,    "\nUInt64        v = %016llX\n", v);
	for(i=0; i<=256; ++i) // i<=510
	{
		q = v;
		RShiftU64(q,i);
		nop();
		fprintf(stdout,"\nv>>%3d         == %016llX\n", i,q);
		q = v;
		RShiftS64(*(SInt64*)&q,i);
		nop();
		fprintf(stdout,  "(SInt64)v>>%3d == %016llX\n", i,q);
		q = v;
		LShiftU64(q,i);
		nop();
		fprintf(stdout,  "v<<%3d         == %016llX\n", i,q);
	}

	if (argc>1)
		i = atoi(a[1]);
	else
		i = Int64Hi(v);

	if (i==0)
	{
		fflush(stdout);
		fprintf(stderr,"\n### %s - divide by zero!\n", argv[0]);
		return 0;
	}

	fprintf(stdout,  "\n(v%%%08X)         ==        %08X\n", i,UMod32(v,i));
	fprintf(stdout,    "(UInt32)(v/%08X)==         %08X\n", i,UDiv32(v,i));
	q = v;
	UDiv64U32(q,i);
	fprintf(stdout,    "v/%08X          == %016llX\n", i,q);
	fprintf(stdout,    "(SInt64)v%%%08X   ==        %08X\n", i,SMod32(*(SInt64*)&v,i));
	fprintf(stdout,    "(SInt32)(v/%08X)==         %08X\n", i,SDiv32(*(SInt64*)&v,i));
	q = v;
	SDiv64S32(*(SInt64*)&q,i);
	fprintf(stdout,    "(SInt64)v/%08X  == %016llX\n", i,q);

	fputs("\nPPC math tests:\n",stdout);

	{
		static const UInt32		iroot_32b[] =
		{
			0, 0,
			1, 1,
			2, 1,
			3, 2,
			4, 2,
			5, 2,
			6, 2,
			7, 3,
			15, 4,
			12345, 111,
			12535140, 3540,
			2147483648, 46341,
			4294901759, 65535,
			4294901760, 65535,
			4294901761, 65536,
			4294967295, 65536,
		};

		int			i = 0;

		for(i=0; i<GET_ARRAY_COUNT(iroot_32b)/2; ++i)
			fprintf(stdout,"isqrt(%u) == %u (should be %d)\n",
				iroot_32b[i*2],isqrt(iroot_32b[i*2]),iroot_32b[i*2+1]);
	}

	fprintf(stdout,"\nisqrt(%u) == %u, __sqrtu32(%u) == %d\n",
		i,isqrt(i),i,__sqrtu32(i));

	fprintf(stdout,"\nisqrt(%u) == %u, __sqrtu32(%u) == %d\n",
		Int64Hi(v),isqrt(Int64Hi(v)),Int64Hi(v),__sqrtu32(Int64Hi(v)));

	fprintf(stdout,"\nisqrt(%u) == %u, __sqrtu32(%u) == %d\n",
		Int64Lo(v),isqrt(Int64Lo(v)),Int64Lo(v),__sqrtu32(Int64Lo(v)));

	fprintf(stdout,"\nisqrt(%llu) == %u, __sqrtu64(%llu) == %u\n",
		v,isqrt64(v),v,__sqrtu64(v));

	return 0;
}

/* from math.c */

  static const UInt16   srhtb[] =
  {
     0x8084, 0x8180, 0x827C, 0x8378, 0x8470, 0x8568, 0x865C, 0x8750,
     0x8840, 0x8930, 0x8A1C, 0x8B0C, 0x8BF4, 0x8CE0, 0x8DC8, 0x8EAC,
     0x8F94, 0x9074, 0x9158, 0x9238, 0x9318, 0x93F8, 0x94D4, 0x95B0,
     0x9688, 0x9760, 0x9838, 0x9910, 0x99E8, 0x9ABC, 0x9B8C, 0x9C60,
     0x9D30, 0x9E00, 0x9ED0, 0x9F9C, 0xA06C, 0xA138, 0xA200, 0xA2CC,
     0xA394, 0xA45C, 0xA524, 0xA5E8, 0xA6AC, 0xA770, 0xA834, 0xA8F8,
     0xA9B8, 0xAA78, 0xAB38, 0xABF8, 0xACB8, 0xAD74, 0xAE30, 0xAEEC,
     0xAFA8, 0xB060, 0xB11C, 0xB1D4, 0xB28C, 0xB344, 0xB3F8, 0xB4B0,
     0xB564, 0xB618, 0xB6CC, 0xB780, 0xB830, 0xB8E4, 0xB994, 0xBA44,
     0xBAF4, 0xBBA0, 0xBC50, 0xBCFC, 0xBDAC, 0xBE58, 0xBF04, 0xBFB0,
     0xC058, 0xC104, 0xC1AC, 0xC254, 0xC300, 0xC3A4, 0xC44C, 0xC4F4,
     0xC598, 0xC640, 0xC6E4, 0xC788, 0xC82C, 0xC8D0, 0xC974, 0xCA14,
     0xCAB8, 0xCB58, 0xCBF8, 0xCC9C, 0xCD3C, 0xCDD8, 0xCE78, 0xCF18,
     0xCFB4, 0xD054, 0xD0F0, 0xD18C, 0xD228, 0xD2C4, 0xD360, 0xD3FC,
     0xD494, 0xD530, 0xD5C8, 0xD660, 0xD6F8, 0xD794, 0xD828, 0xD8C0,
     0xD958, 0xD9F0, 0xDA84, 0xDB1C, 0xDBB0, 0xDC44, 0xDCD8, 0xDD6C,
     0xDE00, 0xDE94, 0xDF28, 0xDFBC, 0xE04C, 0xE0E0, 0xE170, 0xE200,
     0xE294, 0xE324, 0xE3B4, 0xE444, 0xE4D4, 0xE560, 0xE5F0, 0xE680,
     0xE70C, 0xE798, 0xE828, 0xE8B4, 0xE940, 0xE9CC, 0xEA58, 0xEAE4,
     0xEB70, 0xEBFC, 0xEC88, 0xED10, 0xED9C, 0xEE24, 0xEEAC, 0xEF38,
     0xEFC0, 0xF048, 0xF0D0, 0xF158, 0xF1E0, 0xF268, 0xF2F0, 0xF374,
     0xF3FC, 0xF480, 0xF508, 0xF58C, 0xF614, 0xF698, 0xF71C, 0xF7A0,
     0xF824, 0xF8A8, 0xF92C, 0xF9B0, 0xFA34, 0xFAB4, 0xFB38, 0xFBBC,
     0xFC3C, 0xFCC0, 0xFD40, 0xFDC0, 0xFE44, 0xFEC4, 0xFF44, 0xFFFF,
  };

  UInt32 isqrt64(UInt64 n)
  {
     UInt64         t;

     /* to do this effectively, we get the highest ordered bit, and shift up... */
     unsigned long    a = Int64Hi(n), b = Int64Lo(n);
     unsigned long    r, s = LZCount32(a)&-2;

     if (a==0)
        return isqrt(b);

     a = (a<<s)|(b>>=32-s);
     r = srhtb[(a>>24)-64];

     /* ...and shift it back down by half when we are finished */
     s >>= 1;

     r += a/r; r >>= 1;

     /* ...and put it back to the right scale */
     r <<= 16-s;

     /* the table is large enough that we only have to divide and average twice */
     t = n;
     UDiv64U32(t,r);
     Add64U32(t,r);
     HalfU64(t);

     if (Int64Hi(t)!=0)
        r = UINT32_MAX; /* overflow */
     else
        r = Int64Lo(t);

     /* to prevent pre-rounding, we subtract one and test for rounding twice */
     UMul32(t,r,r-1);
     USub64(t,n);
     if (!Int64N(t))
        --r;
     if (r==UINT32_MAX)
        return UINT32_MAX;
     UMul32(t,r,r+1);
     USub64(t,n);
     if (Int64N(t))
        ++r;

     return r;
  }

  UInt32 isqrt(UInt32 n)
  {
     /* to do this effectively, we get the highest ordered bit, and shift up... */
     unsigned long    r, s = LZCount32(n)&-2;
     unsigned long    a = n<<s;

     if (n==0)
        return 0;
     r = srhtb[(a>>24)-64];

     /* ...and shift it back down by half when we are finished */
     s >>= 1;

     /* the table is large enough that we only have to divide and average once */
     r += a/r; r >>= 1;

     /* ...and scale it back down */
     r >>= s;

     /* to prevent pre-rounding, we subtract one and test for rounding twice */
     --r;
     if (r*r+r<n)
        ++r;
     if ((signed)(r*r+r-n)<0)
        ++r;

     return r;
  }
